## deepin-draw 5.9.4

=== CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

# 设置cmake参数
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

# 设置工程名字
project(deepin-draw)

# 是否开启单元测试编译
option(CREATTEST "Compile and generate test program" OFF)

# 是否开启内存泄露检测
option(SANITIZERS "do sanitizers for code" OFF)

# 是否启用accessblity(自动化测试)
option(AC_FUNC_ENABLE "make AT enable" ON)
if(AC_FUNC_ENABLE)
    add_definitions(-DENABLE_ACCESSIBILITY)
endif()

# 是否启用平板模式(平板适配)
option(TABLET_ENABLE "make tablet enable" OFF)
if(TABLET_ENABLE)
    add_definitions(-DENABLE_TABLETSYSTEM)
endif()


set(TOP_PROJECT_DIR ${CMAKE_CURRENT_SOURCE_DIR})
if(CMAKE_BUILD_TYPE MATCHES "Debug")
    #DEBUG时不做优化方便调试
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0")
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O0")
else()
    #加速编译优化参数
    if (CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")
        SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -Wl,-O1 -Wl,--as-needed -Wl,-E -fPIE -ffunction-sections -fdata-sections -Wl,--gc-sections -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi")
        SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O3 -Wl,-O1 -Wl,--as-needed -Wl,-E -fPIE -ffunction-sections -fdata-sections -Wl,--gc-sections -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi")
        SET(CMAKE_EXE_LINKER_FLAGS  "-pie")
    else()
        SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -Wl,-O1 -Wl,--as-needed -Wl,-E -fPIE -ffunction-sections -fdata-sections -Wl,--gc-sections")
        SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O3  -Wl,-O1 -Wl,--as-needed -Wl,-E -fPIE -ffunction-sections -fdata-sections -Wl,--gc-sections")
        SET(CMAKE_EXE_LINKER_FLAGS  "-pie")
    endif()
endif()

if(SANITIZERS)
    set(CMAKE_CXX_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
    set(CMAKE_C_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
endif()

# 设置Qt模块
set(QtModule Core Gui Widgets DBus PrintSupport Svg Concurrent LinguistTools)

# 查找Qt相关的库链接
find_package(Qt5 REQUIRED ${QtModule})

set(SRCDIRS
    ${CMAKE_CURRENT_SOURCE_DIR}/src
    ${CMAKE_CURRENT_SOURCE_DIR}/src/drawshape
    ${CMAKE_CURRENT_SOURCE_DIR}/src/drawshape/drawTools
    ${CMAKE_CURRENT_SOURCE_DIR}/src/drawshape/drawItems
    ${CMAKE_CURRENT_SOURCE_DIR}/src/drawshape/drawItems/bzItems
    ${CMAKE_CURRENT_SOURCE_DIR}/src/frame
    ${CMAKE_CURRENT_SOURCE_DIR}/src/service
    ${CMAKE_CURRENT_SOURCE_DIR}/src/utils
    ${CMAKE_CURRENT_SOURCE_DIR}/src/widgets
    ${CMAKE_CURRENT_SOURCE_DIR}/src/widgets/dialog
    ${CMAKE_CURRENT_SOURCE_DIR}/src/frame/AttributesWidgets
    ${CMAKE_CURRENT_SOURCE_DIR}/src/frame/AttributesWidgets/private
    ${CMAKE_CURRENT_SOURCE_DIR}/src/icon
    ${CMAKE_CURRENT_SOURCE_DIR}/src/icons
    )

# 包含源码文件夹并获取其下所有源代码文件
foreach(item IN LISTS SRCDIRS)
    include_directories(${item})
    list(APPEND SRC_CPPS    ${item}/*.cpp)
    list(APPEND SRC_HEADERS ${item}/*.h)
    list(APPEND SRC_QRCS    ${item}/*.qrc)
endforeach()
FILE (GLOB allSource  ${SRC_CPPS})
FILE (GLOB allHeaders ${SRC_HEADERS})
FILE (GLOB allQrcs    ${SRC_QRCS})

FILE(GLOB targetTsFiles ./translations/*.ts)

# 创建翻译文件(将源文件${allSource} ${allHeaders}关联上${targetTsFiles}的ts文件 然后生成${tragetQmFiles}的qm文件)
qt5_create_translation(tragetQmFiles ${allSource} ${allHeaders} ${targetTsFiles})

# 设置不删除生成的文件夹内容文件（设置此项是为了翻译后的文件不被删除）
set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM 1)

add_executable(${PROJECT_NAME} ${allSource} ${allHeaders} ${allQrcs} ${tragetQmFiles})

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR})
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in ${PROJECT_BINARY_DIR}/config.h @ONLY)

#------------------------------ 添加第三方库  DTK -------------------------------
# 使用第三方库需要用到的一个包
find_package(PkgConfig REQUIRED)

# 检查第三方库(这里检查了名字为dtkwidget的库和名字为dtkgui的库)，然后取名3rd_lib
pkg_check_modules(3rd_lib REQUIRED
        dtkwidget dtkgui
        )
# 添加第三方库的所有文件夹路径到工程中来(注意 *_INCLUDE_DIRS)
target_include_directories(${PROJECT_NAME} PUBLIC ${3rd_lib_INCLUDE_DIRS})


# 将第三方库链接进来(注意 *_LIBRARIES)
target_link_libraries(${PROJECT_NAME} ${3rd_lib_LIBRARIES})

#------------------------------添加第三方库end-------------------------------------

# 将工程与Qt模块链接起来
qt5_use_modules(${PROJECT_NAME} ${QtModule})


# ------------------------------- install script -------------------------------

set(PREFIX /usr)
set(BinDir ${PREFIX}/bin)
set(TranslationDir ${PREFIX}/share/deepin-draw/translations/)
set(DbusDir ${PREFIX}/share/dbus-1/services/)
set(DesktopDir ${PREFIX}/share/applications/)
set(ManIconDir ${PREFIX}/share/icons/deepin/apps/scalable)
set(AppIconDir ${PREFIX}/share/icons/hicolor/scalable/apps)
set(MimeFileDir ${PREFIX}/share/mime/packages)
set(MimeTypeDir ${PREFIX}/share/application)
set(HelpFileDir ${PREFIX}/share/deepin-manual/manual-assets/application)

# install Targets:
#   * <prefix>/lib/libxxx.so
#   * header location after install: <prefix>/include/xxx.h
#   * headers can be included by C++ code `#include <xxx.h>`
install(TARGETS ${PROJECT_NAME}
        EXPORT ${PROJECT_NAME}Targets
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
        RUNTIME DESTINATION /usr/bin
        INCLUDES DESTINATION allHeaders)

# install Translation files:
install(FILES ${tragetQmFiles} DESTINATION ${TranslationDir})

# install DBus file:
install(FILES ./com.deepin.Draw.service DESTINATION ${DbusDir})

# install Desktop icon
install(FILES ./deepin-draw.desktop DESTINATION ${DesktopDir})

# install Manual icon
install(FILES ./src/logo/deepin-draw.svg DESTINATION ${ManIconDir})

# install App icon
install(FILES ./src/logo/deepin-draw.svg DESTINATION ${AppIconDir})

# install MimeFile
install(FILES ./mimetype/deepin-draw.xml DESTINATION ${MimeFileDir})

# install Mimetype
install(FILES ./src/service/x-ddf.xml DESTINATION ${MimeTypeDir})

# install Help File
install(DIRECTORY ./assets/deepin-draw DESTINATION ${HelpFileDir})

# 添加测试子工程
if(CREATTEST)
add_subdirectory(tests)
endif()

=== tests/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

# 设置cmake参数
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

# 设置工程名字
project(deepin-draw-test)

# 添加gocv覆盖率文件的输出
#set(CMAKE_CXX_FLAGS           "-O1 -g -fprofile-arcs -ftest-coverage")
#set(CMAKE_C_FLAGS             "-O1 -g -fprofile-arcs -ftest-coverage")
#set(CMAKE_EXE_LINKER_FLAGS    "-lgcov")
#set(CMAKE_CXX_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -lpthread -fprofile-arcs -ftest-coverage")
#set(CMAKE_CXX_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -fprofile-arcs -ftest-coverage")
#set(CMAKE_C_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
#set(CMAKE_Ｌ_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
#set(CMAKE_EXE_LINKER_FLAGS    "-lgcov")

#注意mips不支持-fsanitize
if (CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")
    set(CMAKE_CXX_FLAGS "-g -O1 -fprofile-arcs -ftest-coverage")
    set(CMAKE_C_FLAGS "-g -O1 -fprofile-arcs -ftest-coverage")
    set(CMAKE_Ｌ_FLAGS "-g -O1 -fprofile-arcs -ftest-coverage")
    set(CMAKE_EXE_LINKER_FLAGS    "-lgcov")
else()
    set(CMAKE_CXX_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -O1 -fprofile-arcs -ftest-coverage")
    set(CMAKE_C_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -O1 -fprofile-arcs -ftest-coverage")
    set(CMAKE_Ｌ_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -O1 -fprofile-arcs -ftest-coverage")
    set(CMAKE_EXE_LINKER_FLAGS    "-fsanitize=undefined,address,leak -lgcov")
    add_definitions(-DENABLE_FSANITIZE)
endif()

#set(CMAKE_CXX_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -O1 -fprofile-arcs -ftest-coverage")
#set(CMAKE_C_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -O1 -fprofile-arcs -ftest-coverage")
#set(CMAKE_Ｌ_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -O1 -fprofile-arcs -ftest-coverage")
#set(CMAKE_EXE_LINKER_FLAGS    "-fsanitize=undefined,address,leak -lgcov")

# 设置Qt模块
if(NOT QtModule)
    set(QtModule Core Gui Widgets DBus PrintSupport Svg Concurrent LinguistTools Test)
else()
    list(APPEND QtModule Test)
endif()

# 查找Qt相关的库链接
find_package(Qt5 REQUIRED ${QtModule})

if(NOT SRCDIRS)
    #定义是独立的cmakelists标记，以表示当前独立打开的工程
    set(INDEPENDENTCMAKELISTS 1)

    message("--it's independent CMake project for deepin-draw test!!")

    # 包含源码文件夹并获取其下所有源代码文件
    set(SRCDIRS
        ${CMAKE_CURRENT_SOURCE_DIR}/../src
        ${CMAKE_CURRENT_SOURCE_DIR}/../src/drawshape
        ${CMAKE_CURRENT_SOURCE_DIR}/../src/drawshape/drawTools
        ${CMAKE_CURRENT_SOURCE_DIR}/../src/drawshape/drawItems
        ${CMAKE_CURRENT_SOURCE_DIR}/../src/drawshape/drawItems/bzItems
        ${CMAKE_CURRENT_SOURCE_DIR}/../src/frame
        ${CMAKE_CURRENT_SOURCE_DIR}/../src/service
        ${CMAKE_CURRENT_SOURCE_DIR}/../src/utils
        ${CMAKE_CURRENT_SOURCE_DIR}/../src/widgets
        ${CMAKE_CURRENT_SOURCE_DIR}/../src/widgets/dialog
        ${CMAKE_CURRENT_SOURCE_DIR}/../src/frame/AttributesWidgets
        ${CMAKE_CURRENT_SOURCE_DIR}/../src/frame/AttributesWidgets/private
        ${CMAKE_CURRENT_SOURCE_DIR}/../src/icon
        ${CMAKE_CURRENT_SOURCE_DIR}/../src/icons
        )
    foreach(item IN LISTS SRCDIRS)
        include_directories(${item})
        list(APPEND SRC_CPPS    ${item}/*.cpp)
        list(APPEND SRC_HEADERS ${item}/*.h)
        list(APPEND SRC_QRCS    ${item}/*.qrc)
    endforeach()

    FILE (GLOB allHeaders ${SRC_HEADERS})
    FILE (GLOB allSource  ${SRC_CPPS})
    FILE (GLOB allQrcs    ${SRC_QRCS})
endif()

#去掉主程序的入口main文件(避免两个main函数入口冲突)
if(INDEPENDENTCMAKELISTS)
    list(REMOVE_ITEM allSource ${CMAKE_CURRENT_SOURCE_DIR}/../src/main.cpp)

    #打印要编译的文件
    foreach(item IN LISTS allHeaders)
        message("Will compile .h   file: ${item}")
    endforeach()

    foreach(item IN LISTS allSource)
        message("Will compile .cpp file: ${item}")
    endforeach()
else()
    list(REMOVE_ITEM allSource ${TOP_PROJECT_DIR}/src/main.cpp)
endif()

# 定义测试用例文件及测试资源文件
set(AllTestFileDirs
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/service
    ${CMAKE_CURRENT_SOURCE_DIR}/testItems
    ${CMAKE_CURRENT_SOURCE_DIR}/testUIs
    ${CMAKE_CURRENT_SOURCE_DIR}/testResource
    )
foreach(item IN LISTS AllTestFileDirs)
    include_directories(${item})
    list(APPEND allTestSourceFiles ${item}/*.cpp)
    list(APPEND allTestSourceFiles ${item}/*.c)
    list(APPEND allTestSourceFiles ${item}/*.h)
    list(APPEND allTestQRCFiles    ${item}/*.qrc)
endforeach()
FILE(GLOB allTestSource ${allTestSourceFiles})
FILE(GLOB allTestQRC ${allTestQRCFiles})

add_executable(${PROJECT_NAME} ${allSource} ${allHeaders} ${allQrcs}
    ${allTestQRC} ${AllQRC} ${allTestSource})

target_link_libraries(${PROJECT_NAME} gmock gmock_main gtest gtest_main pthread)

#set(THREADS_PREFER_PTHREAD_FLAG ON)
#find_package(Threads REQUIRED)
#target_link_libraries(${PROJECT_NAME} Threads::Threads)

# 添加 QTest 测试
add_test(${PROJECT_NAME} COMMAND ${PROJECT_NAME})

set(PROJECT_SRC_NAME deepin-draw)

if(INDEPENDENTCMAKELISTS)
    # Find includes in corresponding build directories
    set(CMAKE_INCLUDE_CURRENT_DIR ON)
    include_directories(${PROJECT_BINARY_DIR})
    include_directories(${PROJECT_SOURCE_DIR})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../config.h.in ${PROJECT_BINARY_DIR}/config.h @ONLY)
    set(LCOV_SRC_PATH_DIR ./CMakeFiles/${PROJECT_NAME}.dir/)
    set(LCOV_WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
else()
    set(LCOV_SRC_PATH_DIR ./CMakeFiles/${PROJECT_NAME}.dir/)
    set(LCOV_WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/tests)
endif()


#------------------------------ 创建'make test'指令---------------------------------------
add_custom_target(test
    COMMAND mkdir -p coverageResult
    WORKING_DIRECTORY ${LCOV_WORKING_DIRECTORY})

add_custom_command(TARGET test
    COMMAND echo " =================== CREAT LCOV REPROT BEGIN ==================== "

    #1.清理原先的gcov信息
    COMMAND lcov --directory ${LCOV_SRC_PATH_DIR} --zerocounters
    COMMAND lcov --directory ${LCOV_SRC_PATH_DIR} --zerocounters
    COMMAND ./${PROJECT_NAME}

    #2.收集gcov信息到.info文件中
    COMMAND lcov --directory ${LCOV_SRC_PATH_DIR} --capture --output-file ./coverageResult/${PROJECT_NAME}_Coverage.info

    #3.过滤一些我们不感兴趣的文件的覆盖率信息
    COMMAND echo " =================== do filter begin ==================== "
    COMMAND lcov --remove ./coverageResult/${PROJECT_NAME}_Coverage.info
    '*/${PROJECT_SRC_NAME}_autogen/*' '*/${PROJECT_NAME}_autogen/*' '*/usr/include/*' '*/tests/*' '*/googletest/*'
    -o ./coverageResult/${PROJECT_NAME}_Coverage.info
    COMMAND echo " =================== do filter end ==================== "

    #3.将.info信息生成报告到reprot文件夹中
    COMMAND genhtml -o ./coverageResult/report ./coverageResult/${PROJECT_NAME}_Coverage.info

    COMMAND echo " =================== CREAT LCOV REPROT END ==================== "

    COMMAND echo " Coverage files have been output to ${LCOV_WORKING_DIRECTORY}/coverageResult/report "

    WORKING_DIRECTORY ${LCOV_WORKING_DIRECTORY}
    )

#'make test'命令依赖与我们的测试程序
add_dependencies(test ${PROJECT_NAME})

#------------------------------ 添加第三方库  DTK -------------------------------

if(INDEPENDENTCMAKELISTS)
    # 使用第三方库需要用到的一个包
    find_package(PkgConfig REQUIRED)

    # 检查第三方库(这里检查了名字为dtkwidget的库和名字为dtkgui的库)，然后取名3rd_lib
    pkg_check_modules(3rd_lib REQUIRED
            dtkwidget dtkgui
            )
endif()

# 添加第三方库的所有文件夹路径到工程中来(注意 *_INCLUDE_DIRS)
target_include_directories(${PROJECT_NAME} PUBLIC ${3rd_lib_INCLUDE_DIRS})

# 将第三方库链接进来(注意 *_LIBRARIES)
target_link_libraries(${PROJECT_NAME} ${3rd_lib_LIBRARIES} gtest)

#------------------------------添加第三方库end-------------------------------------

# 将工程与Qt模块链接起来
qt5_use_modules(${PROJECT_NAME} ${QtModule})

=== debian/changelog ===
deepin-draw (5.9.4-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 27 Apr 2021 16:27:26 +0800

deepin-draw (0.0.1-1) unstable; urgency=medium

  * init 

 -- Deepin Packages Builder <packages@deepin.com>  Fri, 07 Jul 2017 15:49:17 +0800

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk
export QT_SELECT=5
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DCMAKE_BUILD_TYPE=Release \
	  -DCMAKE_INSTALL_PREFIX=/usr \
      -DAPP_VERSION=$(DEB_VERSION_UPSTREAM) -DVERSION=$(DEB_VERSION_UPSTREAM) LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) DH_AUTO_ARGS = --parallel --buildsystem=cmake

## deepin-draw 5.10.6

=== src/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

SET(BASE_LIB "deepinDrawBase" CACHE STRING INTERNAL FORCE)

# 设置cmake参数
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

#set complier/link flags
if(DEEPINDRAW_TEST)
    message(DEEPINDRAW_TESTDEEPINDRAW_TESTDEEPINDRAW_TESTDEEPINDRAW_TEST)
    #0.DEEPINDRAW_TEST mean that we should creat the lib that can get cover info
    #mips not suport -fsanitize
    if (CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")
        set(CMAKE_CXX_FLAGS "-g -O1 -fprofile-arcs -ftest-coverage")
        set(CMAKE_C_FLAGS "-g -O1 -fprofile-arcs -ftest-coverage")
        set(CMAKE_Ｌ_FLAGS "-g -O1 -fprofile-arcs -ftest-coverage -lgcov")
    else()
        message(DEEPINDRAW_TESTDEEPINDRAW_TESTDEEPINDRAW_TESTDEEPINDRAW_TEST1)
        set(CMAKE_CXX_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -O1 -fprofile-arcs -ftest-coverage")
        set(CMAKE_C_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -O1 -fprofile-arcs -ftest-coverage")
        set(CMAKE_Ｌ_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -O1 -fprofile-arcs -ftest-coverage -lgcov")
    endif()
else()
    #1.no DEEPINDRAW_TEST mean that we just need one clearly lib(not include -ftest-coverage or -fsanitize)
    if(CMAKE_BUILD_TYPE MATCHES "Debug")
        #DEBUG时不做优化方便调试
        SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0")
        SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O0")
    else()
        #加速编译优化参数
        if (CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -Wl,-O1 -Wl,--as-needed -Wl,-E -fPIE -ffunction-sections -fdata-sections -Wl,--gc-sections -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi")
            SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O3 -Wl,-O1 -Wl,--as-needed -Wl,-E -fPIE -ffunction-sections -fdata-sections -Wl,--gc-sections -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi")
            SET(CMAKE_EXE_LINKER_FLAGS  "-pie")
        else()
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -Wl,-O1 -Wl,--as-needed -Wl,-E -fPIE -ffunction-sections -fdata-sections -Wl,--gc-sections")
            SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O3  -Wl,-O1 -Wl,--as-needed -Wl,-E -fPIE -ffunction-sections -fdata-sections -Wl,--gc-sections")
            SET(CMAKE_EXE_LINKER_FLAGS  "-pie")
        endif()
    endif()

    #2.sometime we also want to test deepin-draw memery info
    if(DEEPINDRAW_SANITIZERS)
        set(CMAKE_CXX_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
        set(CMAKE_C_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
    endif()
endif()

# 设置Qt模块
set(QtModule Core Gui Widgets DBus PrintSupport Svg Concurrent LinguistTools)

# 查找Qt相关的库链接
find_package(Qt5 REQUIRED ${QtModule})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../config.h.in ${PROJECT_BINARY_DIR}/config.h @ONLY)

set(SRCDIRS
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/drawshape
    ${CMAKE_CURRENT_SOURCE_DIR}/drawshape/drawTools
    ${CMAKE_CURRENT_SOURCE_DIR}/drawshape/drawItems
    ${CMAKE_CURRENT_SOURCE_DIR}/drawshape/drawItems/bzItems
    ${CMAKE_CURRENT_SOURCE_DIR}/frame
    ${CMAKE_CURRENT_SOURCE_DIR}/service
    ${CMAKE_CURRENT_SOURCE_DIR}/utils
    ${CMAKE_CURRENT_SOURCE_DIR}/widgets
    ${CMAKE_CURRENT_SOURCE_DIR}/widgets/dialog
    ${CMAKE_CURRENT_SOURCE_DIR}/frame/AttributesWidgets
    ${CMAKE_CURRENT_SOURCE_DIR}/frame/AttributesWidgets/private
    ${CMAKE_CURRENT_SOURCE_DIR}/res
    )
SET(BASE_LIB_INCLUDEDIRS "${SRCDIRS}" CACHE STRING INTERNAL FORCE)

# 包含源码文件夹并获取其下所有源代码文件
foreach(item IN LISTS SRCDIRS)
    include_directories(${item})
    list(APPEND SRC_CPPS    ${item}/*.cpp)
    list(APPEND SRC_HEADERS ${item}/*.h)
    list(APPEND SRC_QRCS    ${item}/*.qrc)
endforeach()
FILE (GLOB allSource  ${SRC_CPPS})
FILE (GLOB allHeaders ${SRC_HEADERS})
FILE (GLOB allQrcs    ${SRC_QRCS})

FILE(GLOB targetTsFiles ../translations/*.ts)

# 创建翻译文件(将源文件${allSource} ${allHeaders}关联上${targetTsFiles}的ts文件 然后生成${tragetQmFiles}的qm文件)
qt5_create_translation(tragetQmFiles ${allSource} ${allHeaders} ${targetTsFiles})
#qt5_create_translation(tragetQmFiles ${allSource} ${allHeaders} ${targetTsFiles} OPTIONS -no-obsolete)

# 设置不删除生成的文件夹内容文件（设置此项是为了翻译后的文件不被删除）
set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM 1)

qt5_add_resources(RESOURCE_ADDED ${allQrcs})
if(DEEPINDRAW_LINK_DRAWBASELIB_STATIC)
    add_library(${BASE_LIB} STATIC  ${allSource} ${allHeaders} ${RESOURCE_ADDED} ${tragetQmFiles})
else()
    add_library(${BASE_LIB} SHARED  ${allSource} ${allHeaders} ${RESOURCE_ADDED} ${tragetQmFiles})
endif()

set_target_properties(${BASE_LIB}
  PROPERTIES
  VERSION 0.0
  SOVERSION 0
  PUBLIC_HEADER "${allHeaders}")

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR})

#------------------------------ 添加第三方库  DTK -------------------------------
# 使用第三方库需要用到的一个包
find_package(PkgConfig REQUIRED)

# 检查第三方库(这里检查了名字为dtkwidget的库和名字为dtkgui的库)，然后取名3RMODULES
pkg_check_modules(3RMODULES REQUIRED
        dtkwidget dtkgui
        )
# 添加第三方库的所有文件夹路径到工程中来(注意 *_INCLUDE_DIRS)
target_include_directories(${BASE_LIB} PUBLIC ${3RMODULES_INCLUDE_DIRS})
target_link_libraries(${BASE_LIB} ${3RMODULES_LIBRARIES} ${CMAKE_DL_LIBS})

#------------------------------添加第三方库end-------------------------------------

# 将工程与Qt模块链接起来
qt5_use_modules(${BASE_LIB} ${QtModule})

# ------------------------------- install script -------------------------------
set(DbusDir ${PREFIX}/share/dbus-1/services/)
set(DesktopDir ${PREFIX}/share/applications/)
set(ManIconDir ${PREFIX}/share/icons/deepin/apps/scalable)
set(AppIconDir ${PREFIX}/share/icons/hicolor/scalable/apps)
set(MimeFileDir ${PREFIX}/share/mime/packages)
set(MimeTypeDir ${PREFIX}/share/application)
set(HelpFileDir ${PREFIX}/share/deepin-manual/manual-assets/application)

if(NOT DEEPINDRAW_LINK_DRAWBASELIB_STATIC)
    install(TARGETS ${BASE_LIB}
        LIBRARY DESTINATION /usr/lib
        ARCHIVE DESTINATION /usr/lib
        PUBLIC_HEADER DESTINATION /usr/include/${PROJECT_NAME})
endif()

# install Translation files:
install(FILES ${tragetQmFiles} DESTINATION ${TranslationDir})

# install Manual icon
install(FILES ./logo/deepin-draw.svg DESTINATION ${ManIconDir})

# install App icon
install(FILES ./logo/deepin-draw.svg DESTINATION ${AppIconDir})

# install Mimetype
install(FILES ./service/x-ddf.xml DESTINATION ${MimeTypeDir})

add_subdirectory(deepin-draw)

=== debian/changelog ===
deepin-draw (5.10.6-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 22 Dec 2021 08:55:41 +0800

=== debian/control ===
Source: deepin-draw
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: 
 debhelper,
 cmake,
 qtbase5-dev,
 pkg-config,
 libexif-dev,
 libqt5svg5-dev,
 libraw-dev,
 libfreeimage-dev,
 libqt5opengl5-dev,
 libdtkgui-dev,
 qttools5-dev,
 qttools5-dev-tools,
 libdtkwidget-dev,
 libxcb-util0-dev,
 libdtkcore5-bin
Standards-Version: 3.9.8
Homepage: http://www.deepin.org

Package: deepin-draw
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, qt5-image-formats-plugins, deepin-picker-cli
Description: Draw for UOS
 Draw is a lightweight drawing tool for users to freely draw and simply edit images.

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 %:
-	dh $@
+	dh $@ --parallel
 
 override_dh_auto_configure:
 	dh_auto_configure -- \

## deepin-draw 5.10.10

=== CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

# 设置cmake参数
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

# 设置工程名字
project(deepin-draw)

# 是否开启单元测试编译
option(DEEPINDRAW_TEST "only compile and generate deepin-draw-test program." OFF)

# 是否开启内存泄露检测
option(DEEPINDRAW_SANITIZERS "add sanitizers flag for code in gcc.it's a gcc function,but not support on mips." OFF)

# 是否启用accessblity(CI自动化测试.if open, we should add accesibility name for qt widgets.)
option(DEEPINDRAW_AC_FUNC_ENABLE "make CI/AT enable.if open, we should add accesibility name for qt widgets." ON)
if(DEEPINDRAW_AC_FUNC_ENABLE)
    add_definitions(-DENABLE_ACCESSIBILITY)
endif()

# 是否启用平板模式(平板适配)
option(DEEPINDRAW_TABLET_ENABLE "do some outlooking changed with code that could make deepin-draw run on tablet system." OFF)
if(DEEPINDRAW_TABLET_ENABLE)
    add_definitions(-DENABLE_TABLETSYSTEM)
endif()

# if want to support plugins, must generate share drawbaselib instead of static)
option(DEEPINDRAW_LINK_DRAWBASELIB_STATIC "static compile deepin-draw or deepin-draw-test." ON)
if(DEEPINDRAW_LINK_DRAWBASELIB_STATIC)
    add_definitions(-DLINK_DRAWBASELIB_STATIC)
endif()

option(DEEPINDRAW_LOAD_TOOL_PLUGINS "if load tool plugins." OFF)
if(DEEPINDRAW_LOAD_TOOL_PLUGINS AND NOT DEEPINDRAW_LINK_DRAWBASELIB_STATIC)
    add_definitions(-DLOAD_TOOL_PLUGINS)
endif()

#define install destination
set(${CMAKE_INSTALL_PREFIX} usr/bin)
set(PREFIX /usr)
set(BinDir ${PREFIX}/bin)
set(TranslationDir ${PREFIX}/share/deepin-draw/translations/)
if(DEEPINDRAW_LOAD_TOOL_PLUGINS AND NOT DEEPINDRAW_LINK_DRAWBASELIB_STATIC)
    set(PluginDir ${PREFIX}/lib/${CMAKE_LIBRARY_ARCHITECTURE}/deepin-draw/plugins/)
    set(PluginTransDir ${TranslationDir}plugins)
endif()

#1. base lib and main executable
add_subdirectory(src)

#2. test executable
if(DEEPINDRAW_TEST)
    add_subdirectory(tests)
endif()

#3.tool plugins(the plugins is for deepin-draw,so lib of deepindrawbase(define in ./src) must not be static)
if(DEEPINDRAW_LOAD_TOOL_PLUGINS AND NOT DEEPINDRAW_LINK_DRAWBASELIB_STATIC)
    message(support plugins----------------)
    add_subdirectory(deepin-draw-plugins)
endif()

=== deepin-draw-plugins/CMakeLists.txt ===
message("pluginsInstallDir      ===== ${PluginDir}")
message("pluginsTransInstallDir ===== ${PluginTransDir}")
add_subdirectory(calligraphypen)
add_subdirectory(fillTool)
add_subdirectory(eraser)

=== deepin-draw-plugins/eraser/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

project("eraser")

# 设置cmake参数
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

SET(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/plugins)

set(QtModule Core Gui Widgets DBus PrintSupport Svg Concurrent LinguistTools)

# 查找Qt相关的库链接
find_package(Qt5 REQUIRED ${QtModule})

# 定义测试用例文件及测试资源文件
set(AllFileDirs
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/res
    )
foreach(item IN LISTS AllFileDirs)
    include_directories(${item})
    list(APPEND allSourceFiles ${item}/*.cpp)
    list(APPEND allSourceFiles ${item}/*.c)
    list(APPEND allSourceFiles ${item}/*.h)
    list(APPEND allQRCFiles    ${item}/*.qrc)
endforeach()
FILE(GLOB allSourceG ${allSourceFiles})
FILE(GLOB allQRCG ${allQRCFiles})

FILE(GLOB targetTsFFiles ./translations/*.ts)
qt5_create_translation(tragetQmFFiles ${allSourceG} ${targetTsFFiles} OPTIONS -no-obsolete)
# 设置不删除生成的文件夹内容文件（设置此项是为了翻译后的文件不被删除）
set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM 1)

add_library(${PROJECT_NAME} SHARED ${allSourceG} ${allQRCG} ${tragetQmFFiles})

#------------------------------ 添加第三方库  DTK -------------------------------

if(INDEPENDENTCMAKELISTS)
    # 使用第三方库需要用到的一个包
    find_package(PkgConfig REQUIRED)

    # 检查第三方库(这里检查了名字为dtkwidget的库和名字为dtkgui的库)，然后取名3rd_lib
    pkg_check_modules(3rd_lib REQUIRED
            dtkwidget dtkgui
            )
endif()

# 添加第三方库的所有文件夹路径到工程中来(注意 *_INCLUDE_DIRS)
target_include_directories(${PROJECT_NAME} PUBLIC ${3rd_lib_INCLUDE_DIRS} ${BASE_LIB_INCLUDEDIRS})

# 将第三方库链接进来(注意 *_LIBRARIES)
target_link_libraries(${PROJECT_NAME} ${3rd_lib_LIBRARIES} ${BASE_LIB})

#------------------------------添加第三方库end-------------------------------------

# 将工程与Qt模块链接起来
qt5_use_modules(${PROJECT_NAME} ${QtModule})

# install Translation files:
install(FILES ${tragetQmFFiles} DESTINATION ${PluginTransDir})

install(TARGETS ${PROJECT_NAME}
        EXPORT ${PROJECT_NAME}Targets
        LIBRARY DESTINATION ${PluginDir}
        ARCHIVE DESTINATION lib
        RUNTIME DESTINATION ${PluginDir}
        INCLUDES DESTINATION allHeaders)

=== src/deepin-draw/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

# 设置cmake参数
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

# 设置工程名字
project(deepin-draw)

add_executable(${PROJECT_NAME} main.cpp)

target_include_directories(${PROJECT_NAME} PUBLIC ${3RMODULES_INCLUDE_DIRS})

target_link_libraries(${PROJECT_NAME} ${3RMODULES_LIBRARIES} ${CMAKE_DL_LIBS} ${BASE_LIB})

# 将工程与Qt模块链接起来
qt5_use_modules(${PROJECT_NAME} ${QtModule})

install(TARGETS ${PROJECT_NAME}
        EXPORT ${PROJECT_NAME}Targets
        LIBRARY DESTINATION /usr/lib
        ARCHIVE DESTINATION lib
        RUNTIME DESTINATION /usr/bin
        INCLUDES DESTINATION allHeaders)

# install DBus file:
install(FILES ../../com.deepin.Draw.service DESTINATION ${DbusDir})

# install Desktop icon
install(FILES ../../deepin-draw.desktop DESTINATION ${DesktopDir})

# install MimeFile
install(FILES ../../mimetype/deepin-draw.xml DESTINATION ${MimeFileDir})

# install Help File
install(DIRECTORY ../../assets/deepin-draw DESTINATION ${HelpFileDir})

=== debian/changelog ===
deepin-draw (5.10.10-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 10 May 2022 17:49:58 +0800

## deepin-draw 5.11.3

=== tests/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

# 设置cmake参数
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

# 设置工程名字
project(deepin-draw-test)

option(DEEPINDRAW_TEST_OFFSCREENT "test in off screen." ON)
if(DEEPINDRAW_TEST_OFFSCREENT)
    add_definitions(-DTEST_OFFSCREENT)
endif()

option(DEEPINDRAW_TEST_DELETE_ITEM "test delete items fuctions" ON)
if(DEEPINDRAW_TEST_DELETE_ITEM)
    add_definitions(-DTEST_DELETE_ITEM)
endif()

option(DEEPINDRAW_TEST_BLUR_ITEM "test blur fuctions" ON)
if(DEEPINDRAW_TEST_BLUR_ITEM)
    add_definitions(-DTEST_BLUR_ITEM)
endif()

option(DEEPINDRAW_TEST_RECT_ITEM "test rectangle item fuctions" ON)
if(DEEPINDRAW_TEST_RECT_ITEM)
    add_definitions(-DTEST_RECT_ITEM)
endif()

option(DEEPINDRAW_TEST_ELLIPSE_ITEM "test ellipse item fuctions" ON)
if(DEEPINDRAW_TEST_ELLIPSE_ITEM)
    add_definitions(-DTEST_ELLIPSE_ITEM)
endif()

option(DEEPINDRAW_TEST_START_ITEM "test star item fuctions" ON)
if(DEEPINDRAW_TEST_START_ITEM)
    add_definitions(-DTEST_START_ITEM)
endif()

option(DEEPINDRAW_TEST_PICTURE_ITEM "test picture item fuctions" ON)
if(DEEPINDRAW_TEST_PICTURE_ITEM)
    add_definitions(-DTEST_PICTURE_ITEM)
endif()

option(DEEPINDRAW_TEST_TRIANGLE_ITEM "test triangle item fuctions" ON)
if(DEEPINDRAW_TEST_TRIANGLE_ITEM)
    add_definitions(-DTEST_TRIANGLE_ITEM)
endif()

option(DEEPINDRAW_TEST_POLYGON_ITEM "test polygon item fuctions" ON)
if(DEEPINDRAW_TEST_POLYGON_ITEM)
    add_definitions(-DTEST_POLYGON_ITEM)
endif()

option(DEEPINDRAW_TEST_LINE_ITEM "test line item fuctions" ON)
if(DEEPINDRAW_TEST_LINE_ITEM)
    add_definitions(-DTEST_LINE_ITEM)
endif()

option(DEEPINDRAW_TEST_PEN_ITEM "test pen item fuctions" ON)
if(DEEPINDRAW_TEST_PEN_ITEM)
    add_definitions(-DTEST_PEN_ITEM)
endif()

option(DEEPINDRAW_TEST_TEXT_ITEM "test text item fuctions" ON)
if(DEEPINDRAW_TEST_TEXT_ITEM)
    add_definitions(-DTEST_TEXT_ITEM)
endif()
option(DEEPINDRAW_TEST_LAYER_ITEM "test layer item fuctions" ON)
if(DEEPINDRAW_TEST_LAYER_ITEM)
    add_definitions(-DTEST_LAYER_ITEM)
endif()

option(DEEPINDRAW_TEST_CUT_ITEM "test cut fuctions" ON)
if(DEEPINDRAW_TEST_CUT_ITEM)
    add_definitions(-DTEST_CUT_ITEM)
endif()

option(DEEPINDRAW_TEST_SCANLE_ITEM "test scanle item fuctions" ON)
if(DEEPINDRAW_TEST_SCANLE_ITEM)
    add_definitions(-DTEST_SCANLE_ITEM)
endif()

option(DEEPINDRAW_TEST_Z_ITEM "test z item fuctions" ON)
if(DEEPINDRAW_TEST_Z_ITEM)
    add_definitions(-DTEST_Z_ITEM)
endif()

option(DEEPINDRAW_TEST_ITEMALIGNMENT_ITEM "test item alignment fuctions" ON)
if(DEEPINDRAW_TEST_ITEMALIGNMENT_ITEM)
    add_definitions(-DTEST_ITEMALIGNMENT_ITEM)
endif()

option(DEEPINDRAW_TEST_FUNCTION_ITEM "test more other fuctions" ON)
if(DEEPINDRAW_TEST_FUNCTION_ITEM)
    add_definitions(-DTEST_FUNCTION_ITEM)
endif()

option(DEEPINDRAW_TEST_DIALOG_ITEM "test dialog fuctions" ON)
if(DEEPINDRAW_TEST_DIALOG_ITEM)
    add_definitions(-DTEST_DIALOG)
endif()

# 设置Qt模块
set(QtModule Core Gui Widgets DBus PrintSupport Svg Concurrent LinguistTools Test)

# 查找Qt相关的库链接
find_package(Qt5 REQUIRED ${QtModule})

#注意mips不支持-fsanitize
if (CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")
    #set(CMAKE_CXX_FLAGS "-g -O1 -fprofile-arcs -ftest-coverage")
    set(CMAKE_CXX_FLAGS "-g -O1 -fprofile-arcs -ftest-coverage")
    #set(CMAKE_C_FLAGS "-g -O1 -fprofile-arcs -ftest-coverage")
    set(CMAKE_Ｌ_FLAGS "-g -O1 -fprofile-arcs -ftest-coverage")

    #mips not support -fsanitize,so only -lgcov when link ${BASE_LIB}.
    set(CMAKE_EXE_LINKER_FLAGS    "-lgcov")
else()
   #set(CMAKE_CXX_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -O1 -fprofile-arcs -ftest-coverage")
   set(CMAKE_CXX_FLAGS "-g -O1 -fprofile-arcs -ftest-coverage")
   #set(CMAKE_C_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -O1 -fprofile-arcs -ftest-coverage")
    set(CMAKE_Ｌ_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer -g -O1 -fprofile-arcs -ftest-coverage")

    # because ${BASE_LIB} lib is compile with -fsanitize and -lgcov,so we should add those flag when link it.
    set(CMAKE_EXE_LINKER_FLAGS    "-fsanitize=undefined,address,leak -lgcov")

    # notice code that we should output memery use info.
    add_definitions(-DENABLE_FSANITIZE)
endif()

# 定义测试用例文件及测试资源文件
set(AllTestFileDirs
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/service
    ${CMAKE_CURRENT_SOURCE_DIR}/testItems
    ${CMAKE_CURRENT_SOURCE_DIR}/testUIs
    ${CMAKE_CURRENT_SOURCE_DIR}/testResource
    )
foreach(item IN LISTS AllTestFileDirs)
    include_directories(${item})
    list(APPEND allTestSourceFiles ${item}/*.cpp)
    list(APPEND allTestSourceFiles ${item}/*.c)
    list(APPEND allTestSourceFiles ${item}/*.h)
    list(APPEND allTestQRCFiles    ${item}/*.qrc)
endforeach()
FILE(GLOB allTestSource ${allTestSourceFiles})
FILE(GLOB allTestQRC ${allTestQRCFiles})

add_executable(${PROJECT_NAME} ${allTestQRC} ${allTestSource})

target_include_directories(${PROJECT_NAME} PUBLIC ${BASE_LIB_INCLUDEDIRS})
target_link_libraries(${PROJECT_NAME} gmock gmock_main gtest gtest_main pthread ${CMAKE_DL_LIBS} ${BASE_LIB})

#------------------------------ 添加第三方库  DTK -------------------------------

# 使用第三方库需要用到的一个包
find_package(PkgConfig REQUIRED)

# 检查第三方库(这里检查了名字为dtkwidget的库和名字为dtkgui的库)，然后取名3RMODULES
pkg_check_modules(3RMODULES REQUIRED
        dtkwidget dtkgui
        )

# 添加第三方库的所有文件夹路径到工程中来(注意 *_INCLUDE_DIRS)
target_include_directories(${PROJECT_NAME} PUBLIC ${3RMODULES_INCLUDE_DIRS})

# 将第三方库链接进来(注意 *_LIBRARIES)
target_link_libraries(${PROJECT_NAME} ${3RMODULES_LIBRARIES})

#------------------------------添加第三方库end-------------------------------------

# 将工程与Qt模块链接起来
qt5_use_modules(${PROJECT_NAME} ${QtModule})

=== deepin-draw-plugins/calligraphypen/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

SET(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/plugins)

project("calligraphypen")

# 设置cmake参数
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

# 设置Qt模块
set(QtModule Core Gui Widgets DBus PrintSupport Svg Concurrent LinguistTools)

# 查找Qt相关的库链接
find_package(Qt5 REQUIRED ${QtModule})

# 定义测试用例文件及测试资源文件
set(AllFileDirs
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/res
    )
foreach(item IN LISTS AllFileDirs)
    include_directories(${item})
    list(APPEND allSourceFiles ${item}/*.cpp)
    list(APPEND allSourceFiles ${item}/*.c)
    list(APPEND allSourceFiles ${item}/*.h)
    list(APPEND allQRCFiles    ${item}/*.qrc)
endforeach()
FILE(GLOB allSourceG ${allSourceFiles})
FILE(GLOB allQRCG ${allQRCFiles})

FILE(GLOB targetTsFFiles ./translations/*.ts)
qt5_create_translation(tragetQmFFiles ${allSourceG} ${targetTsFFiles} OPTIONS -no-obsolete)

# 设置不删除生成的文件夹内容文件（设置此项是为了翻译后的文件不被删除）
set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM 1)

add_library(${PROJECT_NAME} SHARED ${allSourceG} ${allQRCG} ${tragetQmFFiles})

#------------------------------ 添加第三方库  DTK -------------------------------

if(INDEPENDENTCMAKELISTS)
    # 使用第三方库需要用到的一个包
    find_package(PkgConfig REQUIRED)

    # 检查第三方库(这里检查了名字为dtkwidget的库和名字为dtkgui的库)，然后取名3rd_lib
    pkg_check_modules(3rd_lib REQUIRED
            dtkwidget dtkgui
            )
endif()

# 添加第三方库的所有文件夹路径到工程中来(注意 *_INCLUDE_DIRS)
target_include_directories(${PROJECT_NAME} PUBLIC ${3rd_lib_INCLUDE_DIRS} ${BASE_LIB_INCLUDEDIRS})

# 将第三方库链接进来(注意 *_LIBRARIES)
target_link_libraries(${PROJECT_NAME} ${3rd_lib_LIBRARIES} ${BASE_LIB})

#------------------------------添加第三方库end-------------------------------------

# 将工程与Qt模块链接起来
qt5_use_modules(${PROJECT_NAME} ${QtModule})

# install Translation files:
install(FILES ${tragetQmFFiles} DESTINATION ${PluginTransDir})

install(TARGETS ${PROJECT_NAME}
        EXPORT ${PROJECT_NAME}Targets
        LIBRARY DESTINATION ${PluginDir}
        ARCHIVE DESTINATION lib
        RUNTIME DESTINATION ${PluginDir}
        INCLUDES DESTINATION allHeaders)

=== deepin-draw-plugins/fillTool/CMakeLists.txt ===
# 定义需要的cmake版本
cmake_minimum_required(VERSION 3.10)

project("fillTool")

# 设置cmake参数
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

SET(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/plugins)
# 设置工程名字

set(QtModule Core Gui Widgets DBus PrintSupport Svg Concurrent LinguistTools)

# 查找Qt相关的库链接
find_package(Qt5 REQUIRED ${QtModule})

# 定义测试用例文件及测试资源文件
set(AllFileDirs
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/res
    )
foreach(item IN LISTS AllFileDirs)
    include_directories(${item})
    list(APPEND allSourceFiles ${item}/*.cpp)
    list(APPEND allSourceFiles ${item}/*.c)
    list(APPEND allSourceFiles ${item}/*.h)
    list(APPEND allQRCFiles    ${item}/*.qrc)
endforeach()
FILE(GLOB allSourceG ${allSourceFiles})
FILE(GLOB allQRCG ${allQRCFiles})

FILE(GLOB targetTsFFiles ./translations/*.ts)
qt5_create_translation(tragetQmFFiles ${allSourceG} ${targetTsFFiles} OPTIONS -no-obsolete)
# 设置不删除生成的文件夹内容文件（设置此项是为了翻译后的文件不被删除）
set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM 1)

add_library(${PROJECT_NAME} SHARED ${allSourceG} ${allQRCG} ${tragetQmFFiles})

#------------------------------ 添加第三方库  DTK -------------------------------

if(INDEPENDENTCMAKELISTS)
    # 使用第三方库需要用到的一个包
    find_package(PkgConfig REQUIRED)

    # 检查第三方库(这里检查了名字为dtkwidget的库和名字为dtkgui的库)，然后取名3rd_lib
    pkg_check_modules(3rd_lib REQUIRED
            dtkwidget dtkgui
            )
endif()

# 添加第三方库的所有文件夹路径到工程中来(注意 *_INCLUDE_DIRS)
target_include_directories(${PROJECT_NAME} PUBLIC ${3rd_lib_INCLUDE_DIRS} ${BASE_LIB_INCLUDEDIRS})

# 将第三方库链接进来(注意 *_LIBRARIES)
target_link_libraries(${PROJECT_NAME} ${3rd_lib_LIBRARIES} ${BASE_LIB})

#------------------------------添加第三方库end-------------------------------------

# 将工程与Qt模块链接起来
qt5_use_modules(${PROJECT_NAME} ${QtModule})

# install Translation files:
install(FILES ${tragetQmFFiles} DESTINATION ${PluginTransDir})

install(TARGETS ${PROJECT_NAME}
        EXPORT ${PROJECT_NAME}Targets
        LIBRARY DESTINATION ${PluginDir}
        ARCHIVE DESTINATION lib
        RUNTIME DESTINATION ${PluginDir}
        INCLUDES DESTINATION allHeaders)

=== debian/changelog ===
deepin-draw (5.11.3-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 27 Jul 2022 11:32:45 +0800

deepin-draw (0.0.1) unstable; urgency=medium

  * init 

 -- Deepin Packages Builder <packages@deepin.com>  Fri, 07 Jul 2017 15:49:17 +0800

## deepin-draw 5.11.6

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -120,7 +120,7 @@
 
 # 检查第三方库(这里检查了名字为dtkwidget的库和名字为dtkgui的库)，然后取名3RMODULES
 pkg_check_modules(3RMODULES REQUIRED
-        dtkwidget dtkgui
+        dtkwidget dtkgui dtkcore
         )
 # 添加第三方库的所有文件夹路径到工程中来(注意 *_INCLUDE_DIRS)
 target_include_directories(${BASE_LIB} PUBLIC ${3RMODULES_INCLUDE_DIRS})

=== debian/changelog ===
deepin-draw (5.11.6-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 17 Nov 2022 10:41:59 +0800

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,9 @@
  qttools5-dev-tools,
  libdtkwidget-dev,
  libxcb-util0-dev,
- libdtkcore5-bin
+ libdtkcore5-bin,
+ libgtest-dev,
+ libgmock-dev
 Standards-Version: 3.9.8
 Homepage: http://www.deepin.org
 
@@ -26,3 +28,4 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}, qt5-image-formats-plugins, deepin-picker-cli
 Description: Draw for UOS
  Draw is a lightweight drawing tool for users to freely draw and simply edit images. 
+Recommends: uos-reporter, deepin-event-log

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk
export QT_SELECT=5
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DCMAKE_BUILD_TYPE=Release \
	  -DCMAKE_INSTALL_PREFIX=/usr \
      -DAPP_VERSION=$(DEB_VERSION_UPSTREAM) -DVERSION=$(DEB_VERSION_UPSTREAM) LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

## deepin-draw 6.0.3

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -156,8 +156,5 @@
 # install App icon
 install(FILES ./logo/deepin-draw.svg DESTINATION ${AppIconDir})
 
-# install Mimetype
-install(FILES ./service/x-ddf.xml DESTINATION ${MimeTypeDir})
-
 add_subdirectory(deepin-draw)

=== debian/changelog ===
deepin-draw (6.0.3-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 07 Mar 2023 13:20:56 +0800

deepin-draw (6.0.3) unstable; urgency=medium

  * use xwininfo method to show file name and path.

 -- TagBuilder <tagbuilder@deepin.com>  Tue, 21 Feb 2023 16:05:33 +0800

## deepin-draw 6.5.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -41,12 +41,10 @@
 endif()
 
 #define install destination
-set(${CMAKE_INSTALL_PREFIX} usr/bin)
-set(PREFIX /usr)
-set(BinDir ${PREFIX}/bin)
-set(TranslationDir ${PREFIX}/share/deepin-draw/translations/)
+include(GNUInstallDirs)
+set(TranslationDir ${CMAKE_INSTALL_DATADIR}/deepin-draw/translations/)
 if(DEEPINDRAW_LOAD_TOOL_PLUGINS AND NOT DEEPINDRAW_LINK_DRAWBASELIB_STATIC)
-    set(PluginDir ${PREFIX}/lib/${CMAKE_LIBRARY_ARCHITECTURE}/deepin-draw/plugins/)
+    set(PluginDir ${CMAKE_INSTALL_LIBDIR}/deepin-draw/plugins/)
     set(PluginTransDir ${TranslationDir}plugins)
 endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -132,19 +132,19 @@
 qt5_use_modules(${BASE_LIB} ${QtModule})
 
 # ------------------------------- install script -------------------------------
-set(DbusDir ${PREFIX}/share/dbus-1/services/)
-set(DesktopDir ${PREFIX}/share/applications/)
-set(ManIconDir ${PREFIX}/share/icons/deepin/apps/scalable)
-set(AppIconDir ${PREFIX}/share/icons/hicolor/scalable/apps)
-set(MimeFileDir ${PREFIX}/share/mime/packages)
-set(MimeTypeDir ${PREFIX}/share/application)
-set(HelpFileDir ${PREFIX}/share/deepin-manual/manual-assets/application)
+set(DbusDir ${CMAKE_INSTALL_DATADIR}/dbus-1/services/)
+set(DesktopDir ${CMAKE_INSTALL_DATADIR}/applications/)
+set(ManIconDir ${CMAKE_INSTALL_DATADIR}/icons/deepin/apps/scalable)
+set(AppIconDir ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
+set(MimeFileDir ${CMAKE_INSTALL_DATADIR}/mime/packages)
+set(MimeTypeDir ${CMAKE_INSTALL_DATADIR}/application)
+set(HelpFileDir ${CMAKE_INSTALL_DATADIR}/deepin-manual/manual-assets/application)
 
 if(NOT DEEPINDRAW_LINK_DRAWBASELIB_STATIC)
     install(TARGETS ${BASE_LIB}
-        LIBRARY DESTINATION /usr/lib
-        ARCHIVE DESTINATION /usr/lib
-        PUBLIC_HEADER DESTINATION /usr/include/${PROJECT_NAME})
+        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+        PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})
 endif()
 
 # install Translation files:

=== src/deepin-draw/CMakeLists.txt ===
--- 
+++ 
@@ -22,9 +22,9 @@
 
 install(TARGETS ${PROJECT_NAME}
         EXPORT ${PROJECT_NAME}Targets
-        LIBRARY DESTINATION /usr/lib
-        ARCHIVE DESTINATION lib
-        RUNTIME DESTINATION /usr/bin
+        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
         INCLUDES DESTINATION allHeaders)
 
 # install DBus file:

=== debian/changelog ===
deepin-draw (6.5.8) unstable; urgency=medium

  * chore: New version 6.5.8.

 -- xiepengfei <xiepengfei@uniontech.com>  Fri, 20 Dec 2024 14:04:06 +0800

deepin-draw (6.5.7) unstable; urgency=medium

  * Update version to 6.5.7

 -- xiepengfei <xiepengfei@uniontech.com>  Sat, 14 Dec 2024 15:12:54 +0800

deepin-draw (6.5.6) unstable; urgency=medium

  * Update version to 6.5.6

 -- renbin <renbin@uniontech.com>  Sat, 30 Nov 2024 18:42:50 +0800

deepin-draw (6.5.5) unstable; urgency=medium

  * Update version to 6.5.5

 -- renbin <renbin@uniontech.com>  Sat, 30 Nov 2024 13:46:23 +0800

deepin-draw (6.5.4) unstable; urgency=medium

  * remove kwayland-shell env 

 -- Liu zheng <liuzheng@uniontech.com>  Mon, 11 Nov 2024 11:00:21 +0800

deepin-draw (6.5.3) unstable; urgency=medium

  * chore: Update linglong build script.

 -- wangrong <wangrong@uniontech.com>  Sat, 19 Oct 2024 14:47:21 +0800

deepin-draw (6.5.2) unstable; urgency=medium

  * chore: Adapt linglong.

 -- wangrong <wangrong@uniontech.com>  Mon, 14 Oct 2024 11:03:39 +0800

deepin-draw (6.5.1) unstable; urgency=medium

  * fix: Resolve the issue of not being able to repeatedly open ddf files(Bug: 270887)

 -- renbin <renbin@uniontech.com>  Fri, 20 Sep 2024 13:11:17 +0800

deepin-draw (6.5.0) unstable; urgency=medium

  * feat: adapt treeland(Influence: Treeland)

 -- renbin <renbin@uniontech.com>  Wed, 21 Aug 2024 15:53:20 +0800

deepin-draw (6.0.11) unstable; urgency=medium

  * feat: add avif and heif image format file support
  * fix: the null pointer reference vulnerability
  * fix: too much latency when drawing on 4k screens
  * fix: compile error

 -- wangyu <wangyu@uniontech.com>  Wed, 10 Jul 2024 11:14:38 +0800

deepin-draw (6.0.10) unstable; urgency=medium

  * chore: Update REUSE date

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 16 Oct 2023 17:05:20 +0800

deepin-draw (6.0.9) unstable; urgency=medium

  * feat:[UI] Adapt compact mode
  * fix: [ui] Export dialog box, select path button, add anti aliasing effect

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 25 Sep 2023 17:13:50 +0800

deepin-draw (6.0.8) unstable; urgency=medium

  * fix: After the home directory is changed, deepin-draw fails to start.

 -- renbin <renbin@uniontech.com>  Wed, 30 Aug 2023 16:34:54 +0800

deepin-draw (6.0.7) unstable; urgency=medium

  * fix: Solve the problem that the image becomes large after saving(Bug: 207563)
  * fix: Fix the problem that the file is too large after the image 
         is saved in tif format(Bug: 207563)

 -- Deepin Packages Builder <packages@deepin.org>  Fri, 21 Jul 2023 14:15:55 +0800

deepin-draw (6.0.6) unstable; urgency=medium

  * fix: Fix button in compact mode.(Bug: 193945)(Influence: TitleBar)
  * fix: Adjust titlebar spacing in compact mode.(Bug: 193945)(Influence: TitleBar)
  * fix: Keep float button align vertical center.(Bug: 193945)(Influence: TitleBar)

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 31 May 2023 13:42:37 +0800

deepin-draw (6.0.4) unstable; urgency=medium

  * update version to 6.0.4

 -- TagBuilder <tagbuilder@deepin.com>  Fri, 10 Mar 2023 10:11:45 +0800

=== debian/control ===
--- 
+++ 
@@ -28,4 +28,4 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}, qt5-image-formats-plugins, deepin-picker-cli
 Description: Draw for UOS
  Draw is a lightweight drawing tool for users to freely draw and simply edit images. 
-Recommends: uos-reporter, deepin-event-log
+Recommends: uos-reporter, deepin-event-log, kimageformat-plugins
